﻿Imports System.ComponentModel
Imports Model


Public Class Form1

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        bsMessages.DataSource = Messages
        Log("Starting...")

        ' Load category and supplier combo boxes
        bsCategories.DataSource = _mgr.Categories.ToList()
        bsSuppliers.DataSource = _mgr.Suppliers.ToList()

        ' Pre-load products with category and supplier info
        bsProducts.DataSource = _mgr.Products.Include("Category").Include("Supplier").ToList()
        Log(String.Format("Loaded {0} products", bsProducts.Count))

        ' Select 1st item
        productsDataGrid.CurrentCell = Me.productsDataGrid(1, 0)
    End Sub

    Private Sub Log(message As String)
        message = [String].Format("{0}: {1}", System.Threading.Interlocked.Increment(_messageCounter), message)
        Messages.Insert(0, message)
        ' new messages on top
        logListBox.SelectedItem = message
        logListBox.SelectedItem = Nothing
    End Sub

    Private Sub btn_Save_Click(sender As Object, e As EventArgs) Handles btn_Save.Click
        Log("Saving...")
        Dim saveResult As SaveResult
        Try
            saveResult = _mgr.TrySaveChanges()
            If saveResult.SaveStatus = SaveStatus.Normal Then
                Log("Successfully saved " + saveResult.SavedEntities.Count().ToString() + " entities.")
            ElseIf saveResult.SaveStatus = SaveStatus.NoOperation Then
                Log("No entities to be saved.")
            Else
                Log("Save failed.")
            End If
        Catch exception As Exception
            Log("Save failed: " + exception.Message)
        End Try
    End Sub


    Private ReadOnly _mgr As New NorthwindIBEntities()
    Private Property Messages() As New BindingList(Of String)
    Private _messageCounter As Integer

End Class
